#!/usr/bin/perl

die "Usage: script points_files!" unless @ARGV;

@maxs=(8,33,110,125,7);

for ($a=0;$a<@ARGV;$a++) {
  open F,$ARGV[$a] or die "Cannot open file $ARGV[$a]!";
  @{$pts[$a]}=<F>;
  close F;
}


for ($case=0;$case<5;$case++) {
  my $min=1000;

  for ($sol=0;$sol<@ARGV;$sol++) {
    die "Big error!" unless $pts[$sol][$case] =~ /^(\d+)\s+(\d+)\s+(\w.*)$/;
    $values[$sol] = $2;
    $texts[$sol] = $3;
  }

  for ($sol=0;$sol<@ARGV;$sol++) {
    $min=$values[$sol] if ($values[$sol] < $min) && ($values[$sol] > 0);
  }

  for ($sol=0;$sol<@ARGV;$sol++) {

    if ($values[$sol]) {
      $formulae = 20 - 5 * ($values[$sol] - $min);
      $zarazka = ($values[$sol] <= $maxs[$case]) ? 1 : 0;           # <= because the $values[] is the length of prog + 1
      $values[$sol]=($formulae > $zarazka) ? $formulae : $zarazka;
    }
    
    $num=$case + 1;
    $pts[$sol][$case]="$num $values[$sol] $texts[$sol]\n";
    print "$pts[$sol][$case]";
  }
}

for ($a=0;$a<@ARGV;$a++) {
  open F,">$ARGV[$a]" or die "Cannot open file $ARGV[$a]!";

  for ($case=0;$case<5;$case++) {print F $pts[$a][$case];}

  close F;
}
